#include <Wire.h>
#include "DHT.h"
#include <ESP8266WiFi.h>
#include <SFE_BMP180.h>
#include <WiFiUdp.h>

#include "String.h"

//#define MM_RT_ST // Если раскомментировано -давление в мм.рт.ст


#define COUNT_TIME 78 // счётное время датчика / сбм-20=40с, сбм-20m=78-80с

#define DATA_SEND_PERIOD 5 // слать данные раз в .. секунд

#define DHTPIN 14     // what digital pin we're connected to

#define DHTTYPE DHT22 // DHT 22  (AM2302), AM2321

char buf[200];

uint16_t sbm[COUNT_TIME+1];
uint16_t seconds_passed = 0,
         fon_pulses = 0;

long int fon = 0;
uint16_t tmp_h = 0;
  char status;
  double T,P,p0,a;
  int hum = 0;
  
volatile uint8_t k, ds_t;

bool flag_rad_counted = false,
     flag_do_send_data = false,
     flag_do_blink_rad = false;


static int default_sda_pin = 4;
static int default_scl_pin = 5;
 
SFE_BMP180 pressure;

WiFiUDP Udp;
const char *ssid = "Vault_101";  //
const char *pass = "45667255";

char packetBuffer[255];
unsigned int localPort = 9999;
IPAddress ipServer(192, 168, 10, 1);
IPAddress ipClient(192, 168, 10, 10);
IPAddress Subnet(255, 255, 255, 0);

DHT dht(DHTPIN, DHTTYPE);

void Rad_Pulse()
{
  sbm[0]++;
  flag_do_blink_rad = true;
}



void timer_1Hz_Isr()
{
if (seconds_passed < COUNT_TIME) 
   { 
    seconds_passed++; //для неполного расчёта
    flag_rad_counted = false;
   }
   else
   flag_rad_counted = true;


if (ds_t++ > DATA_SEND_PERIOD) 
      {
        ds_t = 0;
        flag_do_send_data = true;
      }


 for(k=COUNT_TIME+1;k>0;k--)
    {
  sbm[k]=sbm[k-1];
  }
    sbm[0]=0;

timer0_write(ESP.getCycleCount() + 80000000L); // 80MHz == 1sec
}

void setup() {
  pinMode(12, OUTPUT); // LED импульсов датчика
  digitalWrite(12, LOW); // на всякий..

  pinMode(16, OUTPUT); // "НЕ ГОТОВ/ОШИБКА"
  digitalWrite(16, HIGH); // соединимся - погаснем
  

  
  Serial.begin(115200);

  WiFi.mode(WIFI_STA); // 

pinMode(13, INPUT);

noInterrupts();

attachInterrupt(13, Rad_Pulse, FALLING);

timer0_isr_init();
timer0_attachInterrupt(timer_1Hz_Isr);
timer0_write(ESP.getCycleCount() + 80000000L); // 80MHz == 1sec

interrupts();


dht.begin(); 
if (pressure.begin())
    Serial.println("BMP180 init success");
  else
    Serial.println("BMP180 init fail\n\n");

  // Соединение с WiFi
  if ( !ConnectWiFi(ssid, pass) ) {
    Serial.println("Reset ESP8266 ...");
    ESP.reset();
  }
  digitalWrite(16, LOW); // соединились - погаснем
  Serial.print("Signal: "); 
  Serial.println(WiFi.RSSI()); 
  delay(100);
    
  WiFi.config(ipClient, ipServer, Subnet);
  Udp.begin(localPort);
}

void loop() {
//pressure

  
  if (flag_do_send_data)
   { //dsd

if (WiFi.status() != WL_CONNECTED) 
    {
    digitalWrite(16, HIGH); // проблемы сети, зажигаем
    ESP.reset(); // сброс!
    }        

    
  status = pressure.startTemperature();
  if (status != 0)
  {
    // Wait for the measurement to complete:
    delay(status);
    status = pressure.getTemperature(T);
    if (status != 0)
    {
      status = pressure.startPressure(3);
      if (status != 0)
      {
        // Wait for the measurement to complete:
        delay(status);
         status = pressure.getPressure(P,T);
        if (status != 0)
        {

  
        }
        else Serial.println("error retrieving pressure measurement\n");
      }
      else Serial.println("error starting pressure measurement\n");
    }
    else Serial.println("error retrieving temperature measurement\n");
  }
  else Serial.println("error starting temperature measurement\n");
    
    ////bmp180
    flag_do_send_data = false;

    fon_pulses =0;
    for (uint8_t idx=1; idx<seconds_passed+1; idx++)
    {
      fon_pulses += sbm[idx];
    }
    
    fon = fon_pulses * COUNT_TIME / seconds_passed;

    float t = dht.readTemperature(); // оставим, держать датчик в тонусе
    float h = dht.readHumidity();
    // Reading temperature or humidity takes about 250 milliseconds!
    delay(251);
    
    //нан-ы не работают, лень разбираться почему if ((!(isnan(t)))&&(!(isnan(h)))&&((int)h < 100)&&((int)h > 0)) tmp_h = (int)h; // либа любит какать левым мусором если датчик отвечает не сразу, страхуемся
    tmp_h = (int)h;
    if ((tmp_h > 0)&&(tmp_h < 100))  hum = tmp_h; // либа ппц глючная датчик не отвечает периодически
    //
    #ifdef MM_RT_ST
    P = P * 0.7501;
    #endif
    
    sprintf(buf, "{\r\n\"temperature\":%i,\r\n\"humidity\":%i,\r\n\"pressure\":%i,\r\n\"gamma\":%i\r\n}", (int)T, (int)hum, (int)P, (int)fon);
    
    Udp.beginPacket(ipServer,9999);
    //Udp.write("{\r\n\"temp\":");
    Udp.write(buf);
    Udp.write("\r\n");
    Udp.endPacket();
//    Serial.print("Sent: ");Serial.println(buf);

  Serial.print("Signal: ");
  Serial.println(WiFi.RSSI());

  Serial.print("Humidity: ");
  Serial.print(hum);
  Serial.println(" % ");
  Serial.print("Humidity src: ");
  Serial.print(h);
  Serial.println(" % ");
  Serial.print("Temperature: ");
  Serial.print(T);
  Serial.println(" `C ");
  Serial.print("Atm.Pressure: ");
  Serial.print(P);
    #ifdef MM_RT_ST
  Serial.println(" mm ");
    #else
  Serial.println(" hPa ");
    #endif
  Serial.print("Gamma radiation: ");
  Serial.print(fon);
  Serial.println(" uR/H ");

   } ///dsd
 
if (flag_do_blink_rad)
  {
  flag_do_blink_rad = false;
  digitalWrite(12, HIGH);
  delay(50);
  digitalWrite(12, LOW);
  }

}


/**
 * Соединение с WiFi
 */
bool ConnectWiFi(const char *ssid, const char *pass) {
  // Три попытки соединения по WiFi
  for ( int i = 0; i < 3; i++) {
    Serial.print("\nConnecting to: ");
    Serial.println(ssid);
    WiFi.begin(ssid, pass);
    delay(1000);
    // Максиммум 12 раз проверка соединения
    for ( int j = 0; j < 12; j++ ) {
      if (WiFi.status() == WL_CONNECTED) {
        Serial.print("\nWiFi connect true: ");
        Serial.print(WiFi.localIP());
        Serial.print("/");
        Serial.print(WiFi.subnetMask());
        Serial.print("/");
        Serial.println(WiFi.gatewayIP());
        return true;
      }
      delay(1000);
      Serial.print(WiFi.status());
    }
  }
  Serial.println("\nConnect WiFi failed ...");
  return false;
}
